<?php
namespace nur\sery\os\file;

use nur\sery\os\IOException;
use nur\sery\os\sh;

/**
 * Class FileWriter: un fichier accédé en lecture/écriture
 */
class FileWriter extends Stream {
  const DEFAULT_MODE = "a+b";

  function __construct($output, ?string $mode=null, bool $throwOnError=true, ?bool $allowLocking=null) {
    if ($output === null) {
      $fd = STDOUT;
      $close = false;
    } elseif (is_resource($output)) {
      $fd = $output;
      $close = false;
    } else {
      if ($mode === null) $mode = static::DEFAULT_MODE;
      $this->file = $output;
      $this->mode = $mode;
      $fd = null;
      $close = true;
    }
    parent::__construct($fd, $close, $throwOnError, $allowLocking);
  }

  /** @var string */
  protected $file;

  /** @var string */
  protected $mode;

  function getResource() {
    if ($this->fd === null && $this->file !== null) {
      IOException::ensure_value(sh::mkdirof($this->file));
      $this->fd = IOException::ensure_value(@fopen($this->file, $this->mode));
    }
    return parent::getResource();
  }
}
